#pragma once
#include<iostream>
#include<array>
#include<vector>

struct Node
{
        Node( double X, double Y, double Z, sizeT Id, bool Top = false );
	Node() = default;
	~Node() = default;
	Node(const Node&) = default;

	std::array<double, 3> coord;
        sizeT id;
	bool top;
	bool operator==(const Node&) const;
	bool operator!=(const Node&) const;
        friend std::ostream& operator<<(std::ostream& ostr, const Node& node) ;
};

struct FiniteElement
{
        FiniteElement(sizeT IdMaterial, sizeT N_1, sizeT N_2, sizeT N_3, sizeT N4, sizeT id);
	FiniteElement() = default;
	FiniteElement(const FiniteElement&) = default;
	~FiniteElement() = default;

        std::vector<sizeT> id_node;
        sizeT id_material;
        sizeT id;

	bool operator!=(const FiniteElement&) const;
	bool operator==(const FiniteElement&) const;
        friend std::ostream& operator<<(std::ostream& ostr, const FiniteElement& finelem) ;
};

struct BoundaryFiniteElement
{
        BoundaryFiniteElement(sizeT IdSurface, sizeT N_1, sizeT N_2, sizeT N_3, sizeT id);
	BoundaryFiniteElement() = default;
	BoundaryFiniteElement(const BoundaryFiniteElement&) = default;
	~BoundaryFiniteElement() = default;

        std::vector<sizeT> id_node;
        sizeT id;
        sizeT id_surface;
	bool operator!=(const BoundaryFiniteElement&) const;
	bool operator==(const BoundaryFiniteElement&) const;
        friend std::ostream& operator<<(std::ostream& ostr, const BoundaryFiniteElement& boundelem);
};

struct Edge
{
	Edge() = default;
	Edge(const Edge&) = default;
	~Edge() = default;

        Edge(sizeT node1, sizeT node2);
        sizeT first_node;
        sizeT second_node;
        sizeT middle_node;
	bool operator==(const Edge& _edge) const;
};

class HashEdge
{
public:
        sizeT operator()(const Edge&  edge) const ;
};
